package com.izouma.jiashanxia.web;
import com.izouma.jiashanxia.domain.Attractions;
import com.izouma.jiashanxia.service.AttractionsService;
import com.izouma.jiashanxia.dto.PageQuery;
import com.izouma.jiashanxia.exception.BusinessException;
import com.izouma.jiashanxia.repo.AttractionsRepo;
import com.izouma.jiashanxia.utils.ObjUtils;
import com.izouma.jiashanxia.utils.excel.ExcelUtils;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/attractions")
@AllArgsConstructor
public class AttractionsController extends BaseController {
    private AttractionsService attractionsService;
    private AttractionsRepo attractionsRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public Attractions save(@RequestBody Attractions record) {
        if (record.getId() != null) {
            Attractions orig = attractionsRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return attractionsRepo.save(orig);
        }
        return attractionsRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<Attractions> all(@RequestBody PageQuery pageQuery) {
        return attractionsService.all(pageQuery);
    }

    @GetMapping("/get/{id}")
    public Attractions get(@PathVariable Long id) {
        return attractionsRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        attractionsRepo.softDelete(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<Attractions> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

